Gas Station

Published: Oct 16, 2022

Medium Greedy Array

Introduction

A naive idea is to start from every index and check all stations can be reached. However, a greedy approach makes it possible to do in one path. Just calculate gas - cost at each index. If the accumulation of the diff becomes negative, the start should be moved. This way, we can get the answer.

Problem Description

There are n gas stations along a circular route, where the amount of gas at the i-th station is gas[i].

You have a car with an unlimited gas tank and it costs cost[i] of gas to travel from the i-th station to its next (i + 1)-th station. You begin the journey with an empty tank at one of the gas stations.

Given two integer arrays gas and cost, return the starting gas station’s index if you can travel around the circuit once in the clockwise direction, otherwise return -1. If there exists a solution, it is guaranteed to be unique

Constraints:

  • n == gas.length == cost.length
  • 1 <= n <= 10**5
  • 0 <= gas[i], cost[i] <= 10**4

https://leetcode.com/problems/gas-station/

Examples

Example 1
Input: gas = [1,2,3,4,5], cost = [3,4,5,1,2]
Output: 3
Explanation:
Start at station 3 (index 3) and fill up with 4 unit of gas. Your tank = 0 + 4 = 4
Travel to station 4. Your tank = 4 - 1 + 5 = 8
Travel to station 0. Your tank = 8 - 2 + 1 = 7
Travel to station 1. Your tank = 7 - 3 + 2 = 6
Travel to station 2. Your tank = 6 - 4 + 3 = 5
Travel to station 3. The cost is 5. Your gas is just enough to travel back to station 3.
Therefore, return 3 as the starting index.
Example 2
Input: gas = [2,3,4], cost = [3,4,3]
Output: -1
Explanation:
You can't start at station 0 or 1, as there is not enough gas to travel to the next station.
Let's start at station 2 and fill up with 4 unit of gas. Your tank = 0 + 4 = 4
Travel to station 0. Your tank = 4 - 3 + 2 = 3
Travel to station 1. Your tank = 3 - 3 + 3 = 3
You cannot travel back to station 2, as it requires 4 unit of gas but you only have 3.
Therefore, you can't travel around the circuit once no matter where you start.
Example 3
Input: gas = [3,1,1], cost = [1,2,2]
Output: 0

Analysis

At first, check there is enough amount of gas compared to cost. If it is, there should be an unique solution. Calculate gas - cost. If the accumulation of gas - cost becomes negative, it’s impossible to reach to the starting point. So, initialize the parameter and update start index. When the all stations are checked, we get the answer.

Solution

class GasStation:
    def canCompleteCircuit(self, gas: List[int], cost: List[int]) -> int:
        if sum(gas) < sum(cost):
            return -1
        n = len(gas)
        total, start = 0, 0
        for i in range(n):
            total += gas[i] - cost[i]
            if total < 0:
                total = 0
                start = i + 1
        return start

Complexities

  • Time: O(n)
  • Space: O(1)